﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.IdentityModel.Tokens;
using System.Linq;
using System.Security.Claims;
using System.Text;
using System.Threading.Tasks;

namespace ActiveSTS.Handlers
{
    public class CustomAuthenticationHandler : UserNameSecurityTokenHandler
    {
        public override bool CanValidateToken
        {
            get
            {
                return true;
            }
        }

        public override ReadOnlyCollection<ClaimsIdentity> ValidateToken(SecurityToken token)
        {
            UserNameSecurityToken userToken = token as UserNameSecurityToken;

            if (token == null)
            {
                throw new ArgumentNullException("token");
            }

            if (userToken == null)
            {
                throw new SecurityTokenException("Invalid token");
            }

            return new ReadOnlyCollection<ClaimsIdentity>(new ClaimsIdentity[] { AuthenticateUser(userToken.UserName, userToken.Password) });
        }

        protected virtual ClaimsIdentity AuthenticateUser(string username, string password)
        {
            Console.ForegroundColor = ConsoleColor.White;
            Console.WriteLine("---------------------------------------------------------------------");
            Console.WriteLine(string.Format("Attempting login for user {0}", username));

            // Validate the user cridentials at this point. Either against your own ldap directory or database.
            if (username == "Jean-Luc Picard" && password == "Picard-Delta-5") 
            {
                Console.ForegroundColor = ConsoleColor.Green;
                Console.WriteLine(string.Format("Login Successfull."));

                // Add claims for the authenticated user. This can be any information you wish the the bearer of the token to have access to regarding this identity.
                List<Claim> claims = new List<Claim>();

                claims.Add(new Claim(ClaimTypes.SerialNumber, "SP-937-215"));
                claims.Add(new Claim(ClaimTypes.Role, "Captain"));
                claims.Add(new Claim(ClaimTypes.Name, username));
                claims.Add(new Claim(ClaimTypes.DateOfBirth, new DateTime(2305, 07, 13).ToString()));

                var identity = new ClaimsIdentity("CustomAuthentication");
                identity.AddClaims(claims);
                return identity;
            }
            Console.ForegroundColor = ConsoleColor.Red;
            Console.WriteLine(string.Format("Login Failed"));
            throw new System.ServiceModel.FaultException("Unable to Authenticate user.");
            
        }

    }
}
