﻿/*
 * WCF Self hosting sample from www.WayneCliffordBarker.co.za
*/

using System;
using System.Collections.Generic;
using System.Configuration;
using System.IdentityModel.Tokens;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ActiveSTSProxy
{

    public class TrustedIssuerNameRegistry : IssuerNameRegistry
    {
        public override string GetIssuerName(SecurityToken securityToken)
        {
            using (X509SecurityToken x509Token = (X509SecurityToken)securityToken)
            {
                string name = x509Token.Certificate.SubjectName.Name;
                string trustedIssuer = ConfigurationManager.AppSettings["CertificateSubject"];

                return name.Equals(trustedIssuer) ? name : String.Empty;
            }
        }
    }
}
