﻿using System;
using System.Collections.Generic;
using System.IdentityModel.Services;
using System.Linq;
using System.Security.Claims;
using System.Text;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace PassiveClient
{
    public partial class Default : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            this.form1.DefaultButton = LnkSignOut.UniqueID;

            if (ClaimsPrincipal.Current.Identity.IsAuthenticated)
            {
                if (ClaimsPrincipal.Current.Identity is ClaimsIdentity)
                {
                    ClaimsIdentity identity = ClaimsPrincipal.Current.Identity as ClaimsIdentity;
                    lblLoggedInUserName.Text = ClaimsPrincipal.Current.Identity.Name;

                    StringBuilder stringBuilder = new StringBuilder();
                    foreach (Claim claim in identity.Claims)
                    {
                        stringBuilder.Append(claim.Type);
                        stringBuilder.Append(" : ");
                        stringBuilder.Append(claim.Value);
                        stringBuilder.AppendLine();
                    }

                    txtUserClaims.Text = stringBuilder.ToString();
                }
            }
        }

        protected void LnkSignOut_Click(object sender, EventArgs e)
        {
            Uri issuerUri = new Uri(FederatedAuthentication.FederationConfiguration.WsFederationConfiguration.Issuer);
            Uri repleyUri = new Uri(FederatedAuthentication.FederationConfiguration.WsFederationConfiguration.Reply);
            WSFederationAuthenticationModule.FederatedSignOut(issuerUri, repleyUri);
        }

        protected void LnkVisitBlog_Click(object sender, EventArgs e)
        {
            Page.Response.Redirect("http:\\www.waynecliffordbarker.co.za");
        }
    }
}