﻿using STS;
using System;
using System.Collections.Generic;
using System.IdentityModel.Services;
using System.IdentityModel.Tokens;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace PassiveSTS
{
    public partial class Default : System.Web.UI.Page
    {

        protected void Page_Load(object sender, EventArgs e)
        {
            if (this.Request.QueryString["wa"] != null && this.Request.QueryString["wa"] == "wsignout1.0")
            {
                HandleSignout();
            }

            this.form1.DefaultButton = lnkBLogin.UniqueID;
        }

        private void HandleSignout()
        {
            string replyuri = this.Request.QueryString["wreply"];

            this.Session.Abandon();

            // Do clean up work here.

            Page.Response.Redirect(replyuri);
        }


        /// Logs the user into Federation by taking the principal in the session token and serializing it into a response to be transported to the calling client. 
        /// NOTE!!! FEDERATION WORKS WITH CLAIMS NOT THE ACTUAL TOKEN GENERATED BY THE ACTIVE STS! THE CLAIMS ARE SENT AS PART OF THE RESPONSE.
        /// NOTE - The authentication of the user does not happen here. The identity is simply wrapped in a token, signed, encrypted and returned.
        public static void LogUserIntoFederation(SessionSecurityToken token)
        {
            if (token != null && token.ClaimsPrincipal != null && token.ClaimsPrincipal.Identity.IsAuthenticated)
            {
                HttpContext.Current.User = token.ClaimsPrincipal;

                var config = TokenService.GetSTSConfiguration();
                var requestMessage = (SignInRequestMessage)WSFederationMessage.CreateFromUri(HttpContext.Current.Request.Url);
                TokenService securityTokenService = new TokenService(config);
                SignInResponseMessage responseMessage = FederatedPassiveSecurityTokenServiceOperations.ProcessSignInRequest(requestMessage, (System.Security.Claims.ClaimsPrincipal)HttpContext.Current.User, securityTokenService);
                FederatedPassiveSecurityTokenServiceOperations.ProcessSignInResponse(responseMessage, HttpContext.Current.Response);
            }
        }

        protected void lnkBForgotPassword_Click(object sender, EventArgs e)
        {
            throw new NotImplementedException();
        }

        protected void lnkBLogin_Click(object sender, EventArgs e)
        {
            SessionSecurityToken token = null;
            if (!ActiveSTSProxy.Proxy.SignIn(TxtUserName.Text, TxtPassword.Text, out token))
            {
                lblError.Text = "The provided credentials are invalid. Please verify and retry.";
            }
            else
            {
                LogUserIntoFederation(token);
            }            
        }
    }
}